/* Sistemas Integrados TEKNISA

Nome: DTULTATU_PARAMBLOQNFAFIL

@C:\Web_506\Sql\End_Conv\Oracle\03AB_GERTRGO_DTULTATU_PARAMBLOQNFAFIL.sql

Descrio:
Rotina para atualizao de cache da tabela PARAMBLOQNFAFIL

Criao:
29/09/2009 - Fileas Job
*/

CREATE OR REPLACE TRIGGER DTULTATU_PARAMBLOQNFAFIL
BEFORE INSERT OR UPDATE OR DELETE
ON PARAMBLOQNFAFIL FOR EACH ROW

BEGIN
   IF INSERTING THEN 
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF NVL(:NEW.CDFILIAL, 0)        <> NVL(:OLD.CDFILIAL, 0)        OR
         NVL(:NEW.IDENTRSAIDOP, 0)    <> NVL(:OLD.IDENTRSAIDOP, 0)    OR
         NVL(:NEW.CDTIPOOPER, 0)      <> NVL(:OLD.CDTIPOOPER, 0)      OR
         NVL(:NEW.IDLIBERATPOPFIL, 0) <> NVL(:OLD.IDLIBERATPOPFIL, 0) OR
         NVL(:NEW.IDEXIGEAF, 0)       <> NVL(:OLD.IDEXIGEAF, 0)       THEN
         :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
           VALUES ('PARAMBLOQNFAFIL', :OLD.CDFILIAL, 'CDFILIAL=' || :OLD.CDFILIAL ||
                                                    ';IDENTRSAIDOP=' || :OLD.IDENTRSAIDOP ||
                                                    ';CDTIPOOPER=' || :OLD.CDTIPOOPER ||
                                                    ';', SYSDATE);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PARAMBLOQNFAFIL','5.06.032'); END;
/
