<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class GpeOcupacaoh extends \Doctrine\ORM\EntityRepository {
    
    public function retornaUltimoHistorico($nrocupacaom, $nrorg,$dtmescompetenc){
    	$params = array('ocupacaom' => $nrocupacaom, 'nrorg'=>$nrorg, 'dtmescompetenc' => $dtmescompetenc);
        $gpe_Ocupacaoh =  '\Teknisa\Model\Gestaopessoas\Entities\GpeOcupacaoh';
    
        $sql = <<<SQL
SELECT s FROM $gpe_Ocupacaoh s
WHERE s.nrorg = :nrorg
    and s.nrocupacaom = :ocupacaom    
    and s.dtmescompetenc = (
        SELECT MAX(sh.dtmescompetenc) FROM $gpe_Ocupacaoh sh
        WHERE sh.nrorg = s.nrorg
        and sh.nrocupacaom = s.nrocupacaom    
        and sh.dtmescompetenc <= :dtmescompetenc
        )
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return end($result);
    }
    
    public function retornaUltimoHistoricoCdintegracao($cdintegracao, $nrorg, $dtmescompetenc){
    	$params = array('cdintegracao' => $cdintegracao, 'nrorg'=>$nrorg, 'p_dtmescompetenc' => $dtmescompetenc);
        $gpe_Ocupacaom =  '\Teknisa\Model\Gestaopessoas\Entities\GpeOcupacaom';
        $gpe_Ocupacaoh =  '\Teknisa\Model\Gestaopessoas\Entities\GpeOcupacaoh';
    
        $sql = <<<SQL
    SELECT pm, ph
      FROM $gpe_Ocupacaom pm
INNER JOIN $gpe_Ocupacaoh ph WITH ph.nrorg = pm.nrorg
                           AND ph.dtmescompetenc = (SELECT MAX(sub.dtmescompetenc)
                                              	      FROM $gpe_Ocupacaoh sub
                              			             WHERE sub.dtmescompetenc <= :p_dtmescompetenc
                              			               AND ph.nrorg = sub.nrorg
                              			               AND ph.nrocupacaom = sub.nrocupacaom)
                    	   AND ph.nrocupacaom = pm.nrocupacaom
     WHERE pm.nrorg = :nrorg
       AND ph.cdintegracao = :cdintegracao    
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return end($result);
    }
    
    public function retornaUltimoHistoricoCbo($nrcbo, $nrorg, $dtmescompetenc){
    	$params = array('nrcbo' => $nrcbo, 'nrorg'=>$nrorg, 'p_dtmescompetenc' => $dtmescompetenc);
        $gpe_Ocupacaom =  '\Teknisa\Model\Gestaopessoas\Entities\GpeOcupacaom';
        $gpe_Ocupacaoh =  '\Teknisa\Model\Gestaopessoas\Entities\GpeOcupacaoh';
    
        $sql = <<<SQL
    SELECT pm, ph
      FROM $gpe_Ocupacaom pm
INNER JOIN $gpe_Ocupacaoh ph WITH ph.nrorg = pm.nrorg
                           AND ph.dtmescompetenc = (SELECT MAX(sub.dtmescompetenc)
                                              	      FROM $gpe_Ocupacaoh sub
                              			             WHERE sub.dtmescompetenc <= :p_dtmescompetenc
                              			               AND ph.nrorg = sub.nrorg
                              			               AND ph.nrocupacaom = sub.nrocupacaom)
                    	   AND ph.nrocupacaom = pm.nrocupacaom
     WHERE pm.nrorg = :nrorg
       AND ph.nrcbo = :nrcbo    
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return end($result);
    }
    
    public function retornaUltimoHistoricoNmocupacao($nmocupacaoh, $nrorg, $dtmescompetenc){
    	$params = array('nmocupacaoh' => $nmocupacaoh, 'nrorg'=>$nrorg, 'p_dtmescompetenc' => $dtmescompetenc);
        $gpe_Ocupacaom =  '\Teknisa\Model\Gestaopessoas\Entities\GpeOcupacaom';
        $gpe_Ocupacaoh =  '\Teknisa\Model\Gestaopessoas\Entities\GpeOcupacaoh';
    
        $sql = <<<SQL
    SELECT pm, ph
      FROM $gpe_Ocupacaom pm
INNER JOIN $gpe_Ocupacaoh ph WITH ph.nrorg = pm.nrorg
                           AND ph.dtmescompetenc = (SELECT MAX(sub.dtmescompetenc)
                                              	      FROM $gpe_Ocupacaoh sub
                              			             WHERE sub.dtmescompetenc <= :p_dtmescompetenc
                              			               AND ph.nrorg = sub.nrorg
                              			               AND ph.nrocupacaom = sub.nrocupacaom)
                    	   AND ph.nrocupacaom = pm.nrocupacaom
     WHERE pm.nrorg = :nrorg
       AND ph.nmocupacaoh = :nmocupacaoh    
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return end($result);
    }

    
}